//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop
#include "ShadowLabel.h"
#pragma package(smart_init)
#pragma resource "*.res"

inline double py(double h, double w ) {
    return sqrt(pow(h,2)+pow(w,2));
}

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TShadowLabel *)
{
        new TShadowLabel(NULL);
}
//---------------------------------------------------------------------------
__fastcall TShadowLabel::TShadowLabel(TComponent* Owner)
        : TCustomLabel(Owner)
{
    FFontExtras = new TFontExtras();

    /*
    Transparent = true;
    Font->Name  = "Times New Roman";
    Font->Size  = 12;
    */
}
__fastcall TShadowLabel::~TShadowLabel() {
    delete FFontExtras;
}
void __fastcall TShadowLabel::SetAngle(float x) {
    FAngle = (int) x*10.0;
    if( FAngle<0 ) FAngle = 3600-(-FAngle%3600);
    FAngle = FAngle%3600;
    Refresh();
}
float __fastcall TShadowLabel::GetAngle() {
    return (float) FAngle/10.0;
}
void __fastcall TShadowLabel::SetFontExtras(TFontExtras *x) {
    Refresh();
}
void __fastcall TShadowLabel::SetStyle(TExtraBorderStyle x) {
    FBorderStyle = x;
    Refresh();
}

void __fastcall TShadowLabel::Urk(HDC hdc,int Flags) {
    RECT rc;
    HFONT hfnt, hfntPrev;
    SIZE Size;
    AnsiString txt=GetLabelText();
    int Xmin,Ymin,Xmax,Ymax;
    double
        xlt,ylt,
        xrt,yrt,
        xlb,ylb,
        xrb,yrb,
        cside,
        angle=(double)-FAngle*2.0*M_PI/3600.0,
        Ang,AngRest;

    CreateCompatibleDC
    HBITMAP CreateCompatibleBitmap(
    /* Allocate memory for a LOGFONT structure. */

    PLOGFONT plf = (PLOGFONT) LocalAlloc(LMEM_FIXED, sizeof(LOGFONT));

    /* Specify a font */
    plf->lfHeight         = Font->Height;
    plf->lfWidth          = 0;
    plf->lfEscapement     = FAngle;
    plf->lfOrientation    = FAngle;
    plf->lfWeight         = FFontExtras->Boldness?FFontExtras->Boldness:(Font->Style.Contains(fsBold)?FW_BOLD:FW_NORMAL);
    plf->lfItalic         = Font->Style.Contains(fsItalic);
    plf->lfUnderline      = Font->Style.Contains(fsUnderline);
    plf->lfStrikeOut      = Font->Style.Contains(fsStrikeOut);
    plf->lfCharSet        = Font->Charset;
    plf->lfOutPrecision   = OUT_DEFAULT_PRECIS;
    plf->lfClipPrecision  = CLIP_DEFAULT_PRECIS;
    plf->lfQuality        = DEFAULT_QUALITY;
    plf->lfPitchAndFamily = Font->Pitch;
    lstrcpyn(plf->lfFaceName, Font->Name.c_str(),32 );

    hfnt = CreateFontIndirect(plf);

    /*
     * Set the background mode to transparent for the
     * text-output operation.
     */

    SetBkMode(hdc, TRANSPARENT);

    hfntPrev = SelectObject(hdc, hfnt); // Select our font
    GetTextExtentPoint32( hdc,txt.c_str(),txt.Length(), &Size );
    if( FontExtras->Shadows ) {
        Size.cx+=2;
        Size.cy+=2;
    }
    /*// Testing
    if( FBorderStyle != ebsNone ) {
        Size.cx+=2;
        Size.cy+=2;
    }
    */// Testing
    cside   = py(Size.cx,Size.cy);
    Ang     = atan2(Size.cy,Size.cx); // slightly incorrect results...
    AngRest = angle+Ang;

    xlt=0;
    ylt=0;
    xrt = cos(angle)*(double)Size.cx;
    yrt = sin(angle)*(double)Size.cx;
    xrb = cos(AngRest)*cside;
    yrb = sin(AngRest)*cside;
    xlb = sin(-angle)*(double)Size.cy;
    ylb = cos(-angle)*(double)Size.cy;

    Xmin=0.5+min(xlt,min(xrt,min(xlb,xrb)));
    Ymin=0.5+min(ylt,min(yrt,min(ylb,yrb)));
    if( AutoSize ) {
        Xmax=0.5+max(xlt,max(xrt,max(xlb,xrb)));
        Ymax=0.5+max(ylt,max(yrt,max(ylb,yrb)));
        Width =Xmax-Xmin;
        Height=Ymax-Ymin;
    }
    xlt -= Xmin;
    xrt -= Xmin;
    xrb -= Xmin;
    xlb -= Xmin;
    ylt -= Ymin;
    yrt -= Ymin;
    yrb -= Ymin;
    ylb -= Ymin;

    /* Retrieve the client-rectangle dimensions. */

    rc = GetClientRect();
    rc.left   -= Xmin;
    rc.right  -= Xmin;
    rc.top    -= Ymin;
    rc.bottom -= Ymin;

    /*// Testing
    if( FBorderStyle != ebsNone ) {
        MoveToEx(hdc, (int)xlt+.5, (int)ylt+.5, NULL );
        LineTo(hdc, (int)xrt+.5, (int)yrt+.5 );
        LineTo(hdc, (int)xrb+.5, (int)yrb+.5 );
        LineTo(hdc, (int)xlb+.5, (int)ylb+.5 );
        LineTo(hdc, (int)xlt+.5, (int)ylt+.5 );
    }
    */// Testing

    Flags=Flags|DT_NOCLIP;
    if( FontExtras->Shadows ) {
        SetTextColor(hdc, clWhite );
        rc.left++;
        rc.right++;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        rc.left--;
        rc.right--;
        rc.top++;
        rc.bottom++;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        SetTextColor(hdc, cl3DDkShadow );
        rc.left+=2;
        rc.right+=2;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        rc.left--;
        rc.right--;
        rc.top++;
        rc.bottom++;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        SetTextColor(hdc, clWhite );
        rc.top-=2;
        rc.bottom-=2;
        rc.left--;
        rc.right--;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        SetTextColor(hdc, cl3DDkShadow );
        rc.top+=2;
        rc.bottom+=2;
        rc.left+=2;
        rc.right+=2;
        DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);
        rc.top--;
        rc.bottom--;
        rc.left--;
        rc.right--;
    }
    SetTextColor(hdc, Font->Color );
    DrawText(hdc,txt.c_str(),txt.Length(),&rc,Flags);

    SelectObject(hdc, hfntPrev);       // Select the old font
    DeleteObject(hfnt);                // Delete our font

    /* Reset the background mode to its default. */

    //SetBkMode(hdc, OPAQUE);

    /* Free the memory allocated for the LOGFONT structure. */
    LocalFree((LOCALHANDLE) plf);
}

void __fastcall TShadowLabel::DoDrawText(Windows::TRect &Rect, int Flags) {
    AnsiString txt=GetLabelText();
//    DrawText(this->Canvas->Handle,txt.c_str(),txt.Length(),&Rect,Flags);

    Urk(this->Canvas->Handle,Flags);
}

//---------------------------------------------------------------------------
namespace Shadowlabel
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TShadowLabel)};
                 RegisterComponents("Lyncon", classes, 0);
        }
}
//---------------------------------------------------------------------------


