//---------------------------------------------------------------------------
#ifndef ShadowLabelH
#define ShadowLabelH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
enum TExtraBorderStyle {ebsNone,ebsSunken,ebsRaised,ebsSingle};
class TFontExtras : public TPersistent {
private:
    int FBoldness;
    bool FShadows;
    void __fastcall SetBoldness(int x) {
        FBoldness = (x<=0)?0:((x>=1000)?1000:x);
    }
public:
    __fastcall TFontExtras() : TPersistent() {
        FBoldness=0;
        FShadows =false;
    }
__published:
    __property int Boldness = {read=FBoldness, write=SetBoldness};
    __property bool Shadows = {read=FShadows,  write=FShadows};
};

class PACKAGE TShadowLabel : public TCustomLabel
{
private:
    int FAngle;
    TFontExtras *FFontExtras;
    TExtraBorderStyle FBorderStyle;
    void __fastcall SetAngle(float x);
    float __fastcall GetAngle();
    void __fastcall SetFontExtras(TFontExtras *x);
    void __fastcall SetStyle(TExtraBorderStyle x);
    DYNAMIC void __fastcall DoDrawText(Windows::TRect &Rect, int Flags);
protected:
public:
    __fastcall TShadowLabel(TComponent* Owner);
    __fastcall ~TShadowLabel();

    void __fastcall Urk( HDC hdc, int Flags );
__published:
    __property float Angle = {read=GetAngle, write=SetAngle,stored=true};
    __property TFontExtras *FontExtras = {read=FFontExtras,write=SetFontExtras,stored=true};
//    __property TExtraBorderStyle BorderStyle = {read=FBorderStyle,write=SetStyle,stored=true};

    __property Caption;
    __property Color;
    __property Font;

    __property Alignment;
    __property AutoSize;
    __property FocusControl;
    __property Layout;
    __property ShowAccelChar;
    __property Transparent;
    __property WordWrap;

    __property Action;
    __property Align;
    __property Anchors;
    __property BiDiMode;

    __property ClientHeight;


    __property ClientWidth;
    __property Constraints;
    __property ControlState;
    __property ControlStyle;
    __property Cursor;
    __property DockOrientation;
    __property Enabled;
    __property Floating;

    __property Height;
    __property Hint;
    __property HostDockSite;
    __property Left;
    __property LRDockWidth;
    __property Name;
    __property Parent;
    __property ShowHint;
    __property TBDockHeight;
    __property Top;
    __property UndockHeight;
    __property UndockWidth;
    __property Visible;
    __property Width;
    __property ComObject;
    __property ComponentCount;
    __property ComponentIndex;

    __property ComponentState;
    __property ComponentStyle;
    __property DesignInfo;
    __property Owner;
    __property Tag;

};
//---------------------------------------------------------------------------
#endif
